/* config - various defines controlling application behavior */

/*
 * Copyright (c) 2010
 *      Inferno Nettverk A/S, Norway.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. The above copyright notice, this list of conditions and the following
 *    disclaimer must appear in all copies of the software, derivative works
 *    or modified versions, and any portions thereof, aswell as in all
 *    supporting documentation.
 * 2. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by
 *      Inferno Nettverk A/S, Norway.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Inferno Nettverk A/S requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  info@inet.no
 *  Inferno Nettverk A/S
 *  Oslo Research Park
 *  Gaustadalleen 21
 *  NO-0349 Oslo
 *  Norway
 *
 * any improvements or extensions that they make and grant Inferno Nettverk A/S
 * the rights to redistribute these changes.
 *
 */

/* $Id: config.h,v 1.8 2010/10/11 09:07:47 karls Exp $ */

/* default http/spp service port */
#define HTTP_SERV "http"
#define HTTP_PORT "80"

#define SCHEME_HTTP "http"
#define SCHEME_SPP "spp"

#define SPP_SERV "spp"
#define SPP_PORT "1111"

/* default blocksize, used by server */
#define BLOCKSIZE_DEFAULT (512 * 1024)

/* max/min blocksize values */
#define BLOCKSIZE_MIN (64 * 1024)
#define BLOCKSIZE_MAX (1024 * 1024 * 100)

/*
 * appliation level dns resolution
 */

/* max time to wait for dns lookup result */
#define RESOLVE_LOOKUP_TIMEOUT 10

/* max number of retry attempts for failed dns lookups */
#define RESOLVE_MAXRETRIES 2

/* time to cache a dns lookup value (max time for postive/negative response) */
#define RESOLVE_EXPIRYTIME (60 * 60) /* one hour XXX */

/* maximum length for request/response */
#define MAX_REQREPLEN 4096

/*
 * resource management
 */

#define MAXSTREAMS_SERVER 10
#define MAXSTREAMS_SCC 4
#define MAXSTREAMS_CLIENT  5
#define STREAM_ACTIVE_MAX 4
#define PEER_CONN_MAX 5

/*
 * leecher handling
 */

#define FILE_CREDIT_FRESHLIM 15 /* only deny leechers if credit data fresh */
#define FILE_CREDIT_CHECKLIM 20
#define FILE_CREDIT_MAXLIM 40
