/* mconn.h - mconn structures and prototypes */

/*
 * Copyright (c) 2010
 *      Inferno Nettverk A/S, Norway.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. The above copyright notice, this list of conditions and the following
 *    disclaimer must appear in all copies of the software, derivative works
 *    or modified versions, and any portions thereof, aswell as in all
 *    supporting documentation.
 * 2. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by
 *      Inferno Nettverk A/S, Norway.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Inferno Nettverk A/S requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  info@inet.no
 *  Inferno Nettverk A/S
 *  Oslo Research Park
 *  Gaustadalleen 21
 *  NO-0349 Oslo
 *  Norway
 *
 * any improvements or extensions that they make and grant Inferno Nettverk A/S
 * the rights to redistribute these changes.
 *
 */

/* $Id: mconn.h,v 1.3 2010/06/25 22:02:27 karls Exp $ */

#define MCONNMAXCONN 10

void mconn_serv(int);
int mconn_sendreq(int, struct addrinfo *);
int mconn_readrep(int, int *, int *, float *);

/* internal */
struct mconn_req {
	int cnt;
	struct addrinfo *addrs[MCONNMAXCONN];
	int fds[MCONNMAXCONN]; /* file descriptors */
	int errs[MCONNMAXCONN]; /* errno, or zero for no error */
	struct timeval starttimes[MCONNMAXCONN];
	float conntimes[MCONNMAXCONN];
};

struct mconn_rep {
	int idx; /* reply for address received as number idx in request */
	int err; /* connect errno value, zero for success */
	float conntime; /* connect time */
	int descpass; /* set if descriptor is passed */
};

int mconn_readreq(int, struct mconn_req *);
/*int mconn_handlereq(int, struct mconn_req *);*/
int mconn_setupfds(int, struct mconn_req *);
int mconn_pollfds(int, struct mconn_req *);
int mconn_senderrs(int, struct mconn_req *);
int mconn_sendrep(int, struct mconn_req *, int);
float mconn_dur(struct timeval *);
